# GraphQL Export

## Version 8.x-1.x is no longer maintained.

If you have a decoupled Drupal site that leverages GraphQL 3.x, you may want to use this module.

This module has a very simple purpose:

> Every time your Drupal configuration is exported, also export the full GraphQL schema.

If you have the Drupal and front-end application (for example, React) in the same repository, you can use this module to push the full schema to the front-end application. The front-end tooling can then use this, without the front-enders having to do this manually from a running Drupal installation.

An exported GraphQL schema can be used for various purposes:

- Editor autocompletion
- Code generation
- Static typing validation

## Set-up

First, download & install this module. The easiest way to do this is with Composer.
After that, add the following to your settings.php:

```php
$settings['graphql_export'] = [
    'file' => '../schema.json',
    'schema' => 'default:default',
];
```

You can change the file path to whatever you like, as long as the path is writable by Drupal when exporting your config.

When you're ready, just run drush `config:export` (or drush cex if you hate typing) and the full introspection result will be put into the specified file.
